#include <bits/stdc++.h>
using namespace std;

#define inf 1023456789
#define linf 1023456789123456789ll
#define pii pair<int,int>
#define pipii pair<int, pii >
#define pll pair<long long,long long>
#define vint vector<int>
#define vvint vector<vint >
#define ll long long
#define pdd pair<double, double>

#define DEBUG
#ifdef DEBUG
#define db(x) cerr << #x << " = " << x << endl
#else
#define db(x)
#endif

struct graf
{
	int vrcholov;
	vector<vector<int> > sused; //sused[i] je zoznam vrcholov, do ktorych sa da dostat z i-teho vrchola po jednej hrane
	vector<vector<int> > dlzka; //dlzka[i] su dlzky hran iducich z i-teho vrcholu v rovnakom poradi ako su v poli sused
	
	graf(int v = 0)
	{
		vrcholov = v;
		sused.resize(vrcholov);
		dlzka.resize(vrcholov);
	}
	
	void pridaj_hranu(int u, int v, int d)
	{
		sused[u].push_back(v);
		dlzka[u].push_back(d);
	}
	
	int najkratsia_cesta(int start, int ciel) //Dijkstra
	{
		vector<int> vzdialenost(vrcholov, inf);
		vzdialenost[start] = 0;
		priority_queue<pair<int, int>, vector<pair<int, int> >, greater<pair<int, int> > > halda;
		halda.push(pair<int, int> (0, start));
		while(!halda.empty())
		{
			pair<int, int> t = halda.top();
			halda.pop();
			if(t.first > vzdialenost[t.second])continue;
			int ja = t.second;
			for(int i=0; i<sused[ja].size(); i++)
			{
				int on = sused[ja][i];
				if(vzdialenost[on] > vzdialenost[ja] + dlzka[ja][i])
				{
					vzdialenost[on] = vzdialenost[ja] + dlzka[ja][i];
					halda.push(pair<int, int> (vzdialenost[on], on));
				}
			}
		}
		if(vzdialenost[ciel] == inf)return 0;
		return vzdialenost[ciel];
	}
};

int main()
{
	int n, m, a, b, k;
	scanf("%d %d %d %d %d",&n,&m,&a,&b,&k);
	vector<int> x(m+2), y(m+2), s(m+2);
	vector<vector<int> > vchadza_ulica(n), vychadza_ulica(n);
	for(int i=0; i<m; i++)
	{
		scanf("%d %d %d",&x[i],&y[i],&s[i]);
		vchadza_ulica[y[i]].push_back(i);
		vychadza_ulica[x[i]].push_back(i);
	}
	y[m] = a;
	s[m] = 0; //fiktivna ulica - zaciatok cesty
	vchadza_ulica[a].push_back(m);
	x[m+1] = b;
	s[m+1] = inf; //fiktivna ulica - koniec cesty
	vychadza_ulica[b].push_back(m+1);
	
	graf nas_graf(m+2);
	
	for(int i=0; i<n; i++)
	{
		vector<pair<int, int> > vstupne_podla_sirky;
		for(int j=0; j<vchadza_ulica[i].size(); j++)
		{
			vstupne_podla_sirky.push_back(pair<int, int> (s[vchadza_ulica[i][j]], vchadza_ulica[i][j]));
		}
		vstupne_podla_sirky.push_back(pair<int, int> (0, -1)); //zarazka pre binarne vyhladavanie
		sort(vstupne_podla_sirky.begin(), vstupne_podla_sirky.end());
		for(int j=0; j<vychadza_ulica[i].size(); j++)
		{
			int v = vychadza_ulica[i][j];
			int malo = 0, vela = vstupne_podla_sirky.size();
			while(vela - malo > 1)
			{
				int stredne = (malo+vela)/2;
				if(vstupne_podla_sirky[stredne].first - k <= s[v])malo = stredne;
				else vela = stredne;
			}
			int u = vstupne_podla_sirky[malo].second;
			if(u != -1)
			{
				nas_graf.pridaj_hranu(u, v, 1);
			}
		}
		for(int j=1; j<vstupne_podla_sirky.size()-1; j++)
		{
			nas_graf.pridaj_hranu(vstupne_podla_sirky[j].second, vstupne_podla_sirky[j+1].second, 0);
		}
	}
	
	printf("%d\n", nas_graf.najkratsia_cesta(m, m+1) - 1);
	
	return 0;
}